import java.util.concurrent.BrokenBarrierException;
import java.util.concurrent.CyclicBarrier;
import java.util.Random;

public class Scratch implements Runnable {

    private CyclicBarrier waitForIt;
    private Random        generator = new Random();

    public Scratch(CyclicBarrier waitForIt) {
        this.waitForIt = waitForIt;
    }

    public void run() {
        try {
            waitForIt.await(); 
        } catch (InterruptedException ex) { 
        } catch (BrokenBarrierException ex) { 
        }

        try {
            Thread.sleep(generator.nextInt(30)+1);
        } catch (InterruptedException ex) { 
        }

        scratch();
    }

    public void scratch() {
        synchronized (System.out) {
            System.out.println("Scratch!");
        }
    }

}
