import java.util.concurrent.BrokenBarrierException;
import java.util.concurrent.CyclicBarrier;
import java.util.Random;

public class Ben implements Runnable {

    private CyclicBarrier waitForIt;
    private CyclicBarrier meet;
    private Random        generator = new Random();

    public Ben(CyclicBarrier waitForIt, CyclicBarrier meet) {
        this.waitForIt = waitForIt;
        this.meet      = meet;
    }

    public void run() {
        try {
            waitForIt.await(); 
        } catch (InterruptedException ex) { 
        } catch (BrokenBarrierException ex) { 
        }

        try {
            Thread.sleep(generator.nextInt(30)+1);
        } catch (InterruptedException ex) { 
        }

        work();

        try {
            meet.await();
        } catch (InterruptedException ex) { 
        } catch (BrokenBarrierException ex) { 
        }
    }

    public void work() {
        synchronized (System.out) {
            System.out.println("Work!");
        }
    }

}
